bat_template=r'''call "_V_"
cl.exe _W_\rl_pres.c /nologo /MT /W3 /GX /O2 /D"WIN32" /D"NDEBUG" /D"_WINDOWS" /D"_USRDLL" /Fo"_B_/rl_pres.obj" /Fd"_B_/" /FD /c 
link.exe _B_\rl_pres.obj kernel32.lib user32.lib advapi32.lib /nologo /dll /pdb:none /machine:I386 /out:"_B_\rl_pres.dll" /implib:"_B_\rl_pres.lib"
cl.exe _W_\trl_pres.c /nologo /MT /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_CONSOLE" /Fp"_B_/trl_pres.pch" /YX /Fo"_B_/" /Fd"_B_/" /FD /c
link.exe _B_\trl_pres.obj _B_\rl_pres.lib kernel32.lib user32.lib advapi32.lib /nologo /subsystem:console /pdb:none /machine:I386 /out:"_B_/trl_pres.exe" /libpath:"_B_"
'''
def usage(msg='',exit=-1):
    import os
    msg = msg and [msg] or []
    msg += [
    'Use %s [options]' % os.path.basename(sys.argv[0]),
    '\toptions',
    '\t--help    give this help and exit',
    '\t--nosvn   don\'t update the temporary directory for reportlab/rlextra',
    ]
    from rlextra.utils.buildutils import errorMsg
    errorMsg('\n'.join(msg),exit)

def main():
    from reportlab.lib.utils import get_rl_tempdir
    import sys, os, time
    import rlextra, reportlab
    from rlextra.utils.buildutils import    kill, _locateVerDLL, copy2, chdir, path_join,\
                                            runInno, path_dirname, isFile,\
                                            isDir, fetchRL, find_exe,\
                                            _wrapEXE, _makeEXE, _MAGIC, getFlag, invalidFlags,\
                                            stagingArea
    from rlextra.utils.superglob import FileSet
    from rlextra.utils.zipapp import StandardDistros
    help = getFlag('--help')
    nosvn = getFlag('--nosvn')
    I = invalidFlags(())
    if I: usage('Invalid options %s' % (', '.join(I)))
    if help: usage(exit=0)
    try:
        W = chdir(path_dirname(__file__))
    except:
        W = sys.argv[0]
        if not os.path.isabs(W): W = path_join(os.getcwd(),W)
        W = chdir(path_dirname(W))
    project, version = open('version.txt','r').readlines()[0].split()[0:2]
    project_version = '%s-%s' % (project,version)
    build = get_rl_tempdir(os.path.join(project+'_buildarea'))
    app = path_join(build,'ReportLab\\%s' % project_version)
    chdir(W)
    print  'Removing build dir'
    kill(build)

    print 'Making build dir'
    os.makedirs(app)
    stgdir = stagingArea(project)
    print 'Copying version.txt',version, 'examples & readmes etc'
    copy2('readme_install.txt',path_join(app,'README.txt'))
    open(path_join(app,'version.txt'),'w').write('%s %s (%s)\n' % (project, version, time.strftime('%Y%m%d%H%M%S',time.gmtime())))

    print 'copying diagnostic & sample PReS files'
    FS = FileSet('.')
    FS.include('diag*.py')
    FS.include('*.pds')
    FS.include('*.doc')
    FS.include('examples/**/*')
    FS.exclude('**/.svn/*')
    FS.copyFiles(app)

    print 'Making stub dll and exes'
    if sys.hexversion<0x2040000:
        v = r"C:\Program Files\Microsoft Visual Studio\VC98\Bin\VCVARS32.BAT"
    else:
        v = r"C:\Program Files\Microsoft Visual Studio .NET 2003\Vc7\bin\VCVARS32.BAT"
    assert isFile(v),"Cannot locate the msvc compiler setup script"
        
    bat = os.path.join(build,'makeexe.bat')
    f = open(bat,'w')
    f.write(bat_template.replace('_B_',build).replace('_W_',W).replace('_V_',v))
    f.close()
    os.system(bat)
    _wrapEXE(path_join(build,'rl_pres.dll'),path_join(app,'rl_pres.dll'),_MAGIC['RLE'],project_version,version=None)
    _makeEXE(app,'python',0,_MAGIC['RLP'],project_version,script=None,version=None,icon=None,stub='pythonNOPYZ',ext='exe')
    _makeEXE(app,'pythonw',0,_MAGIC['RLP'],project_version,script=None,version=None,icon=None,stub='pythonwNOPYZ',ext='exe')
    copy2(path_join(build,'trl_pres.exe'),app)

    print 'Copying extensions and dlls',
    F = [_locateVerDLL('Python'),_locateVerDLL('PyWinTypes')]
    DLLs = path_join(path_dirname(sys.executable),'DLLs')
    for f in ('_bsddb.pyd','_csv.pyd','_socket.pyd','_sre.pyd','_ssl.pyd','_symtable.pyd','_testcapi.pyd',
            '_tkinter.pyd','_winreg.pyd','bz2.pyd','datetime.pyd','libjpeg.dll','libz.dll','mmap.pyd','parser.pyd',
            'pyexpat.pyd', 'select.pyd', 'tcl84.dll', 'tclpip84.dll', 'tk84.dll', 'unicodedata.pyd',
            'winsound.pyd', 'zlib.pyd',
            ):
        fn = path_join(DLLs,f)
        if isFile(fn): F += [fn]
    exec_prefix = sys.exec_prefix
    FS = FileSet(exec_prefix)
    FS.include('Lib/site-packages/PIL/**/*.pyd')
    FS.include('Lib/site-packages/mx/**/*.pyd')
    FS.include('Lib/site-packages/*.pyd')
    F += FS.getFileNames(abs=1)
    for d in sys.path:
        if isDir(path_join(d,'reportlab')):
            code = d
    FS = FileSet(code)
    FS.include('reportlab/lib/*.pyd')
    F += FS.getFileNames(abs=1)
    DLLs = path_join(app,'DLLs')
    os.makedirs(DLLs)
    for f in F: copy2(f,DLLs)
    print len(F), 'copied!'

    print 'Copying python lib and tcl'
    FS = FileSet(exec_prefix)
    FS.include('Lib/**/*')
    FS.exclude('Lib/site-packages/**/*')
    FS.include('Lib/site-packages/PIL/**/*')
    FS.include('Lib/site-packages/Pmw/**/*')
    FS.exclude('Lib/site-packages/Pmw/Alpha_99_9_example/**/*')
    FS.exclude('Lib/site-packages/Pmw/**/tests/*')
    FS.exclude('Lib/distutils/**/*')
    FS.exclude('Lib/test/**/*')
    FS.exclude('Lib/site-packages/Pmw/**/doc/*')
    FS.include('Lib/site-packages/mx/**/*')
    FS.include('Lib/site-packages/fixedpoint.py')
    FS.exclude('Lib/site-packages/**/*.pyd')
    FS.exclude('Lib/**/*.pyc')
    FS.exclude('Lib/**/*.pyo')
    FS.include('Lib/site-packages/versionCheck.pyc')
    FS.include('tcl/**/*')
    FS.exclude('tcl/**/*.lib')
    FS.exclude('tcl/tk*/demos/**/*')
    FS.copyFiles(app)
    copy2(os.path.join(W,'rlpres.py'),path_join(app,'Lib'))


    sd = StandardDistros()
    sd.pfb = 1
    if not nosvn:
        print 'Fetching reportlab & rlextra from repository'
        fetchRL(stgdir,rla=0,rlx='full',report=lambda x,w=sys.stdout.write: w('\t%s\n'%x),pfb=sd.pfb)

    print 'copying reportlab'
    FS = sd.reportlabDistro(stgdir,full=0)
    FS.include('reportlab/test/**/*')
    FS.copyFiles(app)

    print 'copying rlextra'
    FS = sd.rlextraDistro(stgdir,full=0)
    FS.copyFiles(app)

    #assembly should now be complete we build everything into an installer
    print 'running inno'
    iss = path_join(build,'installer.iss')
    open(iss,'w').write(open('installer.in.iss','r').read().replace('v.vv',version).replace('PPPPPPP',project).replace('_B_',build).replace('_W_',W))
    open(path_join(app,'README.txt'),'w').write(open('readme_install.txt','r').read().replace('v.vv',version).replace('PPPPPPP',project))
    open(path_join(app,project+'_Intro.html'),'w').write(open(project+'_Intro.in.html','r').read().replace('v.vv',version).replace('PPPPPPP',project))
    open(path_join(app,'lib','site-packages','PIL.pth'),'w').write('PIL\n')
    runInno(iss)

if __name__=='__main__': #noruntests
    main()
