#this file is intended to be embedded in C or run through geneps
#it is only guranteed to work cleanly if run in the same folder
#as Diagra.slb and the fonts folder
import sys, os, traceback, time
tstart = time.time()
normal = os.environ.get('diagra_test_normal','0')=='1' or sys.platform!='mac'
if not normal:
	from reportlab.lib.utils import getStringIO
	sys.stdout = sys.stderr = getStringIO()
	import EasyDialogs
else:
	class _EasyDialogs:
		def Message(self,msg):
			print msg
		def ProgressBar(self,title,count,*a):
			class _PB:
				def __init__(self,title,count):
					self.title = title
					self.count = count
				def set(self,x):
					print self.title,'%.2f%% completed' % (100.*x/self.count)
			return _PB(title,count)
	EasyDialogs = _EasyDialogs()

print 'test_diagra started at %s' % time.asctime(time.gmtime())

pb = EasyDialogs.ProgressBar("Diagra test routines", 164, "tests:")  
pbs = 0
ok = 0

try:
	from reportlab.graphics import renderPM, renderPDF
	from rlextra.graphics.guiedit.diagnostic import DiagnosticDrawing 
	from rlextra.graphics.quickchart import getTestDrawing
	if sys.platform=='mac': import macfs, macostools
	print 'imports of renderPM/PDF etc succeeded'
	ok += 1
except:
	print '!!!!!imports of renderPM/PDF failed'
	traceback.print_exc()
print 
pbs += 1
pb.set(pbs)

try:
	renderPM.test()
	print 'renderPM.test succeeded'
	ok += 12
except:
	print '!!!!!renderPM.test failed'
	traceback.print_exc()
print 
pbs += 12
pb.set(pbs)

for obj,name in ((DiagnosticDrawing,'DiagnosticDrawing'),(getTestDrawing,'TestDrawing'),
				):
	for fmt in 'pdf', 'pict':
		try:
			d = obj()
			fn = os.path.join(os.getcwd(),'pmout',name+'.'+fmt)
			f = open(fn,'wb')
			f.write(d.asString(fmt))
			f.close()
			if sys.platform=='mac':
				macfs.FSSpec(fn).SetCreatorType("????", "BINA")
				macostools.touched(fn)
			print '%s succeeded wrote pmout%s%s.%s' % (name,os.sep,name,fmt)
			ok += 1
		except:
			print '!!!!!%s failed' % name
			traceback.print_exc()
		pbs=pbs+1
		pb.set(pbs)
print 

try:
	t0 = time.time()
	for i in xrange(100):
		d = getTestDrawing()
		s = d.asString('pict')
		pbs=pbs+1
		pb.set(pbs)
	t1 = time.time()
	print 'Timing test: time for 100 test drawings rendered to string: %.2f seconds.' % (t1-t0)
except:
	print '!!!!!Timing test failed!'
	traceback.print_exc()
print 

try:
	from rlextra.graphics.qctest import main
	main()
	print 'quickcharts tests succeeded'
	ok += 46
except:
	print '!!!!!quickcharts tests failed'
	traceback.print_exc()
print 
pbs += 46
pb.set(pbs)

print 'Finished total time taken: %.2f seconds.' % (time.time()-tstart)
print 'Check the folder pmout for the result drawings and index.html.'


if not normal:
	del pb
	import __main__
	#this will be returned to the caller as resultString
	__main__._rl_embed_result = sys.stdout.getvalue().replace('\n','\r')
	sys.stdout = sys.__stdout__
	sys.stderr = sys.__stderr__

EasyDialogs.Message("""Finished Diagra acceptance tests.
Please inspect the output in the pmout folder and the contents of your output text file.
""")
