[Setup]
; Note:  we *want* the version number to show up everywhere.
; Which of these controls App Path???
AppName=PPPPPPP-v.vv
AppVerName=PPPPPPP-v.vv
AppId=PPPPPPP-v.vv
AppVersion=v.vv
AppCopyright=Copyright  2004 ReportLab Inc
WizardImageBackColor=$4e5688
WizardImageFile=_W_\RLImage.bmp
WizardSmallImageFile=_W_\RLSmallImage.bmp

; Default install dir; value of {app} later (unless user overrides).
; {sd} = system root drive, probably "C:".
DefaultDirName={pf}\ReportLab\PPPPPPP-v.vv

; Start menu folder name; value of {group} later (unless user overrides).
DefaultGroupName=PPPPPPP-v.vv

SourceDir=_B_\ReportLab
OutputDir=_W_
OutputBaseFilename=PPPPPPPSetup-v.vv

AppPublisher=ReportLab Inc
AppPublisherURL=http://www.reportlab.com
AppSupportURL=http://www.reportlab.com
AppUpdatesURL=http://www.reportlab.com

;AlwaysCreateUninstallIcon=yes
ChangesAssociations=no
UninstallLogMode=new
MinVersion=4.0,4.0
AllowRootDirectory=1
Compression=bzip/9

[Messages]
BeveledLabel=PPPPPPP-v.vv Setup

; The fewer screens the better; leave these commented.
;LicenseFile=LICENSE
;InfoBeforeFile=Misc\NEWS

; uncomment the following line if you want your installation to run on NT 3.51 too.
; MinVersion=4,3.51

[Types]
Name: normal; Description: "Select desired components"; Flags: iscustom

[Files]
; Caution:	Using forward slashes instead screws up in amazing ways.
; Unknown:	By the time Components (and other attrs) are added to these lines, they're
; going to get awfully long.  But don't see a way to continue logical lines across
; physical lines.
Source: PPPPPPP-v.vv\*.*;  DestDir: "{app}"; flags: ignoreversion recursesubdirs
Source: PPPPPPP-v.vv\rl_pres.dll; DestDir: "{code:PReSUtilitiesDir|{app}}"; flags: ignoreversion restartreplace; Check: PReSUtilitiesDirCheck

[Icons]
Name: "{group}\PPPPPPP Introduction"; Filename: "{app}\PPPPPPP_Intro.html"; WorkingDir: "{app}"
Name: "{group}\GUI Edit"; Filename: "{app}\pythonw.exe"; parameters: """{app}\rlextra\graphics\guiedit\guiedit.py"""; WorkingDir: "{app}"
Name: "{group}\Uninstall PPPPPPP"; Filename: "{uninstallexe}"; WorkingDir: "{app}"

[Registry]
;the install directory
Root: HKCU; Subkey: "Software\ReportLab\PPPPPPP-v.vv"; Flags: uninsdeletekey
Root: HKCU; Subkey: "Software\ReportLab\PPPPPPP-v.vv"; ValueType: string; ValueName: "InstallPath"; ValueData: "{app}"
Root: HKCU; Subkey: "Software\ReportLab\PPPPPPP-v.vv"; ValueType: string; ValueName: "Version"; ValueData: "v.vv"
Root: HKLM; Subkey: "Software\ReportLab\PPPPPPP-v.vv"; Flags: uninsdeletekey
Root: HKLM; Subkey: "Software\ReportLab\PPPPPPP-v.vv"; ValueType: string; ValueName: "InstallPath"; ValueData: "{app}"
Root: HKLM; Subkey: "Software\ReportLab\PPPPPPP-v.vv"; ValueType: string; ValueName: "Version"; ValueData: "v.vv"

[run]
FileName: "{app}\README.txt"; WorkingDir: "{app}"; Description: "View Distribution README"; StatusMsg: "Viewing README.txt"; Flags: shellexec postinstall skipifdoesntexist skipifsilent

[UninstallDelete]
Type: filesandordirs; Name: "{app}\reportlab"
Type: filesandordirs; Name: "{app}\rlextra"
Type: filesandordirs; Name: "{app}\DLLs"
Type: filesandordirs; Name: "{app}\Lib"
Type: files; Name: "{app}\*.pyc"
Type: files; Name: "{app}\*.pyo"
Type: dirifempty; Name: "{app}"
Type: dirifempty; Name: "{pf}\ReportLab"

[Code]
program Setup;
	function noPyClass(): Boolean;
		begin
		Result := not RegValueExists(HKEY_CLASSES_ROOT, '.py', '')
		end;
	function hasPyClass(): Boolean;
		begin
		Result := not noPyClass()
		end;
	function PReSUtilitiesDirCheck(): Boolean;
		var dummy: string;
		begin
		Result := RegQueryStringValue(HKLM, 'Software\PrintSoft\PReS\SYSTEM', 'UtilitiesDirectory', dummy);
		end;
	function PReSUtilitiesDir(default: String): String;
		var test: Boolean;
		begin
		test := RegQueryStringValue(HKLM, 'Software\PrintSoft\PReS\SYSTEM', 'UtilitiesDirectory', Result);
		if not test then begin
			Result := default;
			end;
		end;
begin
end.
