#include <stdio.h>
#if defined(WIN32)||defined(macintosh)
#	include <io.h>
#endif
#include <stdlib.h>
#include <string.h>
#if defined(WIN32)
#	define WIN32_LEAN_AND_MEAN
#	include <windows.h>
#	if !defined(_CONSOLE)
#		define FATALERROR(x) MessageBox(NULL, x, "Fatal Error!", MB_OK | MB_ICONEXCLAMATION)
#		define OTHERERROR(x) MessageBox(NULL, x, "Error!", MB_OK | MB_ICONWARNING)
#	endif
#	define EXPORT(typ,fnc,arg) __declspec(dllexport) typ fnc arg
#endif
#ifndef EXPORT
#define EXPORT(typ, fnc, arg) typ fnc arg
#endif

#ifndef	FATALERROR
#	define FATALERROR(x) fprintf(stderr,x)
#	define OTHERERROR(x) fprintf(stderr,x)
#endif
#undef DEBUG
#if defined(_DEBUG) || defined(_RL_DEBUG)
#	define VS(arg) fprintf(stderr, arg)
#	define VS1(fmt,arg) fprintf(stderr,fmt,arg)
#	define VS2(fmt,arg1,arg2) fprintf(stderr,fmt,arg1,arg2)
#	define VS3(fmt,arg1,arg2,arg3) fprintf(stderr,fmt,arg1,arg2,arg3)
#else
#	define VS(arg)
#	define VS1(fmt,arg)
#	define VS2(fmt,arg1,arg2)
#	define VS3(fmt,arg1,arg2,arg3)
#endif
#ifdef  _RL_VERBOSE
#       undef _RL_VERBOSE
#       define _RL_VERBOSE 1
#else
#       define _RL_VERBOSE 0
#endif
#define DECLPROC(result, name, args) typedef result (__cdecl *__PROC__##name) args; __PROC__##name name = NULL;
#define GETPROC(dll, result, name, args) name = (__PROC__##name)GetProcAddress (dll, #name); if (!name) FATALERROR ("Cannot GetProcAddress for " #name)
#define DECLVAR(vartyp, name) vartyp *name = NULL;
#define GETVAR(dll, vartyp, name) name = (vartyp *)GetProcAddress (dll, #name); if (!name) FATALERROR ("Cannot GetProcAddress for " #name)

typedef _typeobject;
typedef struct _object {
	int ob_refcnt; 
	struct _typeobject *ob_type;
} PyObject;
#define _Py_Dealloc(op) (*(op)->ob_type->tp_dealloc)((PyObject *)(op))
#define Py_INCREF(op) ((op)->ob_refcnt++)
#define Py_DECREF(op) \
	if (--(op)->ob_refcnt != 0) \
		; \
	else \
		_Py_Dealloc((PyObject *)(op))
#define Py_XDECREF(op) if ((op) == NULL) ; else Py_DECREF(op)
typedef void (*destructor)(PyObject *);
typedef struct _typeobject {
	int ob_refcnt; 
	struct _typeobject *ob_type;
	int ob_size; 
	char *tp_name; /* For printing */
	int tp_basicsize, tp_itemsize; /* For allocation */
	destructor tp_dealloc;
	/* ignore the rest.... */
} PyTypeObject;

/*Python vars & functions*/
DECLVAR (int, Py_NoSiteFlag);
DECLVAR (int, Py_VerboseFlag);
DECLVAR (int, Py_IgnoreEnvironmentFlag);
#define Py_file_input 257
DECLPROC(int, Py_Initialize, (void));
DECLPROC(int, Py_Finalize, (void));
DECLPROC(int, PyRun_SimpleString, (char *));
DECLPROC(void, Py_SetProgramName, (char *));
DECLPROC(PyObject *, PyImport_ImportModule, (char *));
DECLPROC(int, PyObject_SetAttrString, (PyObject *, char *, PyObject *));
DECLPROC(PyObject*, PyObject_GetAttrString, (PyObject *, char *));
#define  PyObject_DelAttrString(O,A) PyObject_SetAttrString((O),(A),NULL)
DECLPROC(PyObject *, PyList_New, (int));
DECLPROC(char*, PyString_AsString, (PyObject *));
DECLPROC(PyObject*, PyString_FromString, (char*));
DECLPROC(int, PyString_Size, (PyObject *));
DECLPROC(PyObject*, PyString_FromFormatV, (const char*,...));
DECLPROC(int, PyList_Append, (PyObject *, PyObject *));
DECLPROC(PyObject *, Py_BuildValue, (char *, ...));
DECLPROC(PyObject *, PyFile_FromFile, (FILE *, char *, char *, int));
DECLPROC(PyObject *, PyObject_CallFunction, (PyObject *, char *, ...));
DECLPROC(PyObject *, PyModule_GetDict, (PyObject *));
DECLPROC(PyObject *, PyDict_GetItemString, (PyObject *, char *));
DECLPROC(PyObject *, PyErr_Occurred, () );
DECLPROC(PyObject *, PyErr_Clear, () );
DECLPROC(void, PyErr_Print, () );
DECLPROC(void, Py_SetPythonHome, (char *));
DECLPROC(char *, Py_GetPath, (void));
DECLPROC(PyObject *, PyRun_File, (FILE*,char*,int,PyObject *,PyObject *));
DECLPROC(int,PySys_SetArgv,(int, char **));
#ifdef _RL_EMBED_RESULT
DECLPROC(int,PyString_Check,(PyObject *));
#endif
#ifdef	BUILD_FREEZE
#	if defined(WIN32)
	DECLPROC(void,PyWinFreeze_ExeInit,(void));
	DECLPROC(void, PyWinFreeze_ExeTerm,(void));
	DECLPROC(int,PyInitFrozenExtensions,(void));
#	endif
#endif
static	int	pyvers;
static	char homepath[_MAX_PATH+1];

static char* _rl_run_string ="def _rl_run_string():\n"
#if defined(_DEBUG) || defined(_RL_DEBUG)
"	import sys, os\n\
	print 'sys.exec_prefix',sys.exec_prefix\n\
	print 'sys.prefix',sys.prefix\n\
	print 'sys.path',sys.path\n\
	print 'os.environ[\\'PYTHONHOME\\']',os.environ.get('PYTHONHOME',None)\n\
	print 'os.environ[\\'PYTHONPATH\\']',os.environ.get('PYTHONPATH',None)\n\
	print 'os.environ[\\'PATH\\']',os.environ.get('PATH',None)\n"
#endif
"	import __main__,sys,StringIO\n\
	sys.stderr = StringIO.StringIO()\n\
	try:\n\
		exec __main__._rl_embed_arg+'\\n' in __main__.__dict__,__main__.__dict__\n\
	except:\n\
		__main__._rl_uncaught = 1\n\
		import traceback\n\
		traceback.print_exc()\n\
	__main__._rl_embed_error = sys.stderr.getvalue()\n\
	sys.stderr = sys.__stderr__\n\
_rl_run_string()\n\
del _rl_run_string";

static	HINSTANCE DLL=0;
static	int	initialised=0;
static	int	verbose=_RL_VERBOSE;
typedef struct {
		char*	errorString;
#ifdef _RL_EMBED_RESULT
		int		resultStringLength;
		char*	resultString;
#	define RL_EMBED_INIT {NULL,0,NULL,0}
#else
#	define RL_EMBED_INIT {NULL,0}
#endif
		int		uncaughtError;
		} rl_embed_rt;

static	void write_error(char *msg,rl_embed_rt* prlert)
{
	if(!prlert->errorString){
		prlert->errorString = strdup(msg);
		}
	else{
		prlert->errorString = (char*)realloc(prlert->errorString,strlen(prlert->errorString)+strlen(msg)+1);
		strcat(prlert->errorString,msg);
		}
}

int PyRun_Format(const char *format, ...)
{
	va_list vargs;
	PyObject* string;
	int	i = -1;

	va_start(vargs, format);
	string = PyString_FromFormatV(format, vargs);
	if(string){
		i = PyRun_SimpleString(PyString_AsString(string));
		Py_DECREF(string);
		}
	va_end(vargs);
	return i;
}

HINSTANCE loadPython(int pyvers, char* homepath, rl_embed_rt* prlert)
{
	HINSTANCE dll;
	char dllpath[_MAX_PATH+25];
	VS("Loading python\n");
	sprintf(dllpath, "%sDLLs\\python%02d.dll", homepath, pyvers);
	dll = LoadLibraryEx(dllpath, NULL, LOAD_WITH_ALTERED_SEARCH_PATH);
	if(!dll){
		char* msg="Failed to load python dll\n";
		VS(msg);
		write_error(msg,prlert);
		}
	else{
		VS(dllpath);VS("\n");
		/* Thomas Heller's code*/
		VS("Getting entry points\n");
		GETVAR(dll, int, Py_NoSiteFlag);
		GETVAR(dll, int, Py_VerboseFlag);
		GETVAR(dll, int, Py_IgnoreEnvironmentFlag);
		GETPROC(dll, int, Py_Initialize, (void));
		GETPROC(dll, int, Py_Finalize, (void));	
		GETPROC(dll, int, PyRun_SimpleString, (char *));
		GETPROC(dll, void, Py_SetProgramName, (char *));
		GETPROC(dll, PyObject *, PyImport_ImportModule, (char *));
		GETPROC(dll, int, PyObject_SetAttrString, (PyObject *, char *, PyObject *));
		GETPROC(dll, PyObject*, PyObject_GetAttrString, (PyObject *, char *));
		GETPROC(dll, PyObject *, PyList_New, (int));
		GETPROC(dll, char*, PyString_AsString, (PyObject *));
		GETPROC(dll, PyObject*, PyString_FromString, (char*));
		GETPROC(dll, int, PyString_Size, (PyObject *));
		GETPROC(dll, PyObject* , PyString_FromFormatV, (const char*,...));
		GETPROC(dll, int, PyList_Append, (PyObject *, PyObject *));
		GETPROC(dll, PyObject *, Py_BuildValue, (char *, ...));
		GETPROC(dll, PyObject *, PyFile_FromFile, (FILE *, char *, char *, int));
		GETPROC(dll, PyObject *, PyObject_CallFunction, (PyObject *, char *, ...));
		GETPROC(dll, PyObject *, PyModule_GetDict, (PyObject *));
		GETPROC(dll, PyObject *, PyDict_GetItemString, (PyObject *, char *));
		GETPROC(dll, PyObject *, PyErr_Occurred, () );
		GETPROC(dll, PyObject *, PyErr_Clear, () );
		GETPROC(dll, void, PyErr_Print, () );
		GETPROC(dll, void, Py_SetPythonHome, (char *));
		GETPROC(dll, char *, Py_GetPath, (void));
		GETPROC(dll, PyObject *, PyRun_File, (FILE*,char*,int,PyObject*,PyObject*));
		GETPROC(dll, int,PySys_SetArgv,(int, char **));
#ifdef _RL_EMBED_RESULT
		GETPROC(dll, int,PyString_Check,(PyObject *));
#endif
#ifdef	BUILD_FREEZE
#	if defined(WIN32)
		GETPROC(dll,void,PyWinFreeze_ExeInit,(void));
		GETPROC(dll,void, PyWinFreeze_ExeTerm,(void));
		GETPROC(dll,int,PyInitFrozenExtensions,(void));
#	endif
#endif
		}

	return dll;
}

static int getRegistryInstallPath(HKEY rootKey, char* id, char* homepath)
{
	HKEY	key=0;
	long	bufSize;
	int		n;
	char	*fmt="Software\\ReportLab\\%s";
	char	*regpath = malloc(strlen(id)+strlen(fmt)+1);

	sprintf(regpath, fmt, id);
	bufSize=_MAX_PATH;
	VS1("REGISTRY PATH: %s\n", regpath);
	if((n=RegOpenKey(rootKey,regpath,&key))==ERROR_SUCCESS &&
		(n=RegQueryValueEx(key, "InstallPath",NULL,NULL, homepath, &bufSize))==ERROR_SUCCESS) n = 1;
	else{
		VS2("Can't Find Registry PYTHONHOME key=%8.8x err=%d\n",key,n);
		n = 0; /*error*/
		}
	if(key) RegCloseKey(key);
	if(regpath) free(regpath);
	return n;
}

int get_homepath(char* thisfile, char* homepath, char *project)
{
	char	*p, *q, *s;
	int		n;
	VS("Finding InstallPath\n");
	if(!getRegistryInstallPath(HKEY_LOCAL_MACHINE,project,homepath)
			&& !getRegistryInstallPath(HKEY_CURRENT_USER,project,homepath)){
		VS("Trying EXE for homepath\n");
		strcpy(homepath, thisfile);
		p = homepath+strlen(homepath);
		while(p>=homepath && *p!='/' && *p != '\\') p--;
		if(p>homepath) *++p = 0;
		else {
			FATALERROR("Can't Find PYTHONHOME\n");
			return -1;
			}
		}
	if(homepath[strlen(homepath)-1]!='\\') strcat(homepath,"\\");
	VS1("Found HOMEPATH=%s\n", homepath);
	/*adjust the path to include homepath/DLLs*/
	p = getenv("PATH");
	n = strlen(thisfile)+2*strlen(homepath)+11;	/*we add DLLs and PATH=*/
	if(p) n += strlen(p)+1;
	s = (char*)malloc(n);
	strcpy(s,"PATH=");
	strcpy(s+5,thisfile);
	q = s+strlen(s);
	while(q>=s && *q!='/' && *q != '\\') q--;
	*q = 0;
	strcat(s,";");
	strcat(s,homepath);
	s[strlen(s)-1] = 0;
	strcat(s,";");
	strcat(s,homepath);
	strcat(s,"DLLs");
	if(p){
		strcat(s,";");
		strcat(s,p);
		}
	VS1("Adjusted PATH=%s\n",s);
	_putenv(s);
	return 0;
}

int openSelf(char* thisfile, char *homepath, char **project, int *pyvers)
{
	FILE*	fp;
	char	*p;
#	define RLE_MAGIC "RLE\07\04\01\013\012"
	typedef struct {
		unsigned short projectlen;
		unsigned short pyvers;
		char magic[8];
		} cookie;
	cookie	c;
	int	cs = sizeof(cookie);
	p = thisfile+strlen(thisfile)-4;
	if (strnicmp(p, ".dll", 4) != 0) strcat(thisfile, ".dll");
	VS1("Opening self=%s\n", thisfile);
	fp = fopen(thisfile, "rb");
	if(fp == NULL){
		FATALERROR("Cannot open self: ");
		FATALERROR(thisfile);
		return -1;
		}
	fseek(fp, 0, SEEK_END);
	if (fseek(fp, -(int)cs, SEEK_END)){
L0:		FATALERROR("executable appears to be invalid");
		return -1;
		}
	fread(&c, sizeof(cookie), 1, fp);
	if (strncmp((char*)&c.magic, RLE_MAGIC, 8)){
#if	defined(_DEBUG) || defined(_RL_DEBUG)
		int i;
		VS("RLE_MAGIC:");
		for(i=0;i<8;i++){
			VS1("%2.2X",RLE_MAGIC[i]);
			}
		VS("\nc.magic:");
		for(i=0;i<8;i++){
			VS1(" %2.2X",c.magic[i],);
			}
		VS("\n");
#endif
		FATALERROR("DLL has bad magic - quitting!");
		return -1;
		}
	if (fseek(fp, -cs-(int)c.projectlen, SEEK_END)) goto L0;
	*project = malloc((size_t)c.projectlen + 1);
	fread(*project, (int)c.projectlen, 1, fp);
	(*project)[c.projectlen] = 0;
	VS2("projectlen=%d project='%s'\n",(int)c.projectlen,*project);
	if (get_homepath(thisfile,homepath,*project)) return -1;
	VS("closing self\n");
	fclose(fp);
	*pyvers = (int)c.pyvers;
	return 0;
}

#if	0
static	void set_python_home_path(char *thisfile,char *homepath)
{
	char *pypath;
	int	i;
	pypath = (char*)malloc(2*strlen(homepath)+13+50);
	strcpy(pypath,"PYTHONHOME=");
	strcpy(pypath+11,homepath);
	i = strlen(pypath)-1;
	if(pypath[i]=='\\' || pypath[i]=='/') pypath[i]=0;
	VS1("Set %s\n",pypath);
	_putenv( pypath );
	strcpy(pypath,"PYTHONPATH=");
	strcpy(pypath+11,homepath);
	i = strlen(pypath)-1;
	if(pypath[i]=='\\' || pypath[i]=='/') pypath[i]=0;
	strcat(pypath,";");
	strcat(pypath,thisfile);
	i=strlen(pypath)-1;
	while(i){
		if(pypath[i]==';' || pypath[i]=='\\' || pypath[i]=='/'){
			pypath[i]=0;
			break;
			}
		i--;
		}
	_putenv( pypath );
	free(pypath);
}
#endif

static	char* PYTHONHOME;
static int pyStart(rl_embed_rt *prlert)
{
	char *project=NULL;
#if	defined(macintosh)||defined(WIN32)
	char thisfile[_MAX_PATH+1];
#else
	char *thisfile = "lib_rl_embed";
#endif
#ifdef macintosh
	OSErr err;
#endif
#ifdef	BUILD_FREEZE
	PyImport_FrozenModules = _PyImport_FrozenModules;
	Py_FrozenFlag = 1; /* Suppress errors from getpath.c */
#	ifdef WIN32
		PyInitFrozenExtensions();
#	endif
#endif

	if(initialised){
		if(initialised<0){
			write_error("Python initialisation already failed\n",prlert);
			return -1;
			}
		else return 0;
		}

	initialised = -1;
	
#ifdef macintosh
	err = PyMac_GetFullPathname(&library_fss, thisfile, _MAX_PATH);
	if (err != noErr) {
		write_error("can't get library path\n",prlert);
		return -1;
	}
#endif
#ifdef WIN32
	if (!GetModuleFileNameA(DLL, thisfile, _MAX_PATH)) {
		FATALERROR("System error - unable to load!");
		return -1;
		}
#endif
	if (openSelf(thisfile,homepath,&project,&pyvers)) return -1;
#if 0
	set_python_home_path(thisfile,homepath);
#endif
	/*now launch python ...*/
	if(!loadPython(pyvers,homepath,prlert)) return -1;
	PYTHONHOME=strdup(homepath);
	Py_SetPythonHome(PYTHONHOME);
	VS("Setting Python vars\n");
	*Py_NoSiteFlag = 1;
	*Py_IgnoreEnvironmentFlag=1; /* e.g. PYTHONPATH, PYTHONHOME */
	VS1("Py_NoSiteFlag=%d\n", *Py_NoSiteFlag);
	if(verbose) *Py_VerboseFlag = 1;
	
	Py_SetProgramName(thisfile);
	VS("Initializing Python\n");	
#ifdef macintosh
#if 1 /* !defined(_DEBUG) && !defined(_RL_DEBUG) */
	/*
	** This call redirects sys.stdin/out/err to the bitbucket.
	** If you don't do this the test program will end up with two
	** console windows and menu bars in one process: one created by
	** the MSL library in the main program and one by the MSL library
	** in PythonCore. The two don't share any code or globals,
	** but as they do use the same set of constants for menu commands
	** and such things get very messy and it becomes difficult to even
	** quit the application. But still: disabling this code may allow you
	** to see a traceback or other vital information.
	**
	** The alternative is to pass actual output handlers, see macglue.h.
	*/
	PyMac_SetConsoleHandler(PyMac_DummyReadHandler,
		PyMac_DummyWriteHandler, PyMac_DummyWriteHandler);
#endif
	mac_addlibresources();
	PyMac_Initialize();
#else
	Py_Initialize();
#	ifdef	BUILD_FREEZE
#		ifdef WIN32
		PyWinFreeze_ExeInit();
#		endif
#	endif
#endif
	Py_GetPath();
#ifndef macintosh
	{
	char *dummy_argv[2] = {"embedded_python",0};
	PySys_SetArgv(1, dummy_argv);
	}
#endif
	VS("Setting up sys.path\n");
#ifdef	BUILD_FREEZE
	if(PyImport_ImportFrozenModule("__main__")<=0){
		VS("Error: __main__ not frozen or bad initialisation during Python DLL initialisation\n");
		write_error("Error: __main__ not frozen or bad initialisation during Python DLL initialisation\n",prlert);
		return -1;
		}
	PyRun_SimpleString("import sys;sys.path=[];sys.exec_prefix=sys.executable=''");
#else
	{
	char *fmt="def __rl_sys_path(thisfile,homepath):\n\
	import sys,os\n\
	sys.prefix=sys.exec_prefix=homepath\n\
	sys.argv=[thisfile]\n\
	sys.__embedded__=1\n\
	thisfile=os.path.dirname(thisfile.lower())\n\
	homepath=homepath.lower()\n\
	sys.path = filter(lambda x: x.startswith(homepath) or x.startswith(thisfile) or not x,map(str.lower,sys.path))\n\
	if homepath not in sys.path: sys.path.insert(0,homepath)\n\
	if thisfile not in sys.path: sys.path.insert(0,thisfile)\n\
__rl_sys_path(r'%s',r'%s')\n\
del __rl_sys_path\n";
	int	hpe = strlen(homepath)-1;
	char c=homepath[hpe];
	if(c=='\\') homepath[hpe] = 0;
	PyRun_Format(fmt,thisfile,homepath);
	if(c=='\\') homepath[hpe] = '\\';
	}
#endif

	VS("Importing module site\n");
	PyRun_SimpleString("import site;");
	if(PyErr_Occurred()){
		VS("Error occurred during Python DLL initialisation\n");
		write_error("Error occurred during Python DLL initialisation\n",prlert);
		if(project) free(project);
		return -1;
		}
	initialised=1;

	if(project) free(project);
	{
	PyObject *m = PyImport_ImportModule("__main__");
	if(m){
		PyObject *v = PyString_FromString(thisfile);
		if(v){
			PyObject_SetAttrString(m,"_rl_embed_location",v);
			Py_DECREF(v);
			}
		Py_DECREF(m);
		}
	}
	return 0;
}

static int pyFinish(int verbose,rl_embed_rt *prlert)
{
	if(initialised>0){
		VS("Finalizing Python\n");
		Py_Finalize();
		}
}

static PyObject* _get__main__(char* val,rl_embed_rt *prlert)
{
	PyObject *m, *v;
	m = PyImport_ImportModule("__main__");
	if(!m){
		VS("Can't find __main__\n");
		write_error("Can't find __main__\n",prlert);
		}
	else{
		int	err=0;
		PyObject_DelAttrString(m,"_rl_embed_error");
		PyObject_DelAttrString(m,"_rl_uncaught");
#ifdef _RL_EMBED_RESULT
		PyObject_DelAttrString(m,"_rl_embed_result");
#endif
		if(PyErr_Occurred()) PyErr_Clear();
		v = PyString_FromString(val);
		if(!v) err = 1;
		else if (PyObject_SetAttrString(m,"_rl_embed_arg",v)==-1) err = 1;
		if(err){
			write_error("Couldn't set __main__._rl_embed_arg'\n",prlert);
			Py_DECREF(m);
			m = NULL;
			}
		if(v) Py_DECREF(v);
		}
	return m;
}

static int _finish_run(PyObject* m, rl_embed_rt *prlert)
{
	char	*s;
	PyObject* e;
	int		ucerr = prlert->errorString && prlert->errorString[0];
	e = PyObject_GetAttrString(m,"_rl_embed_error");
	if(e){
		s = PyString_AsString(e);
		if(!s) s = "Error in _rl_embed_error\n";
		if(*s){
			VS(s);
			write_error(s,prlert);
			}
		Py_DECREF(e);
		}
	e = PyObject_GetAttrString(m,"_rl_uncaught");
	if(e){
		Py_DECREF(e);
		ucerr |= 2;
		}
#ifdef _RL_EMBED_RESULT
	e = PyObject_GetAttrString(m,"_rl_embed_result");
	if(e){
		if(!PyString_Check(e)){
			write_error("_rl_embed_result must be a string",prlert);
			}
		else {
			int n = PyString_Size(e);
			s = prlert->resultString = (char*)malloc((unsigned long)n+1);
			prlert->resultStringLength = n;
			memcpy(s,PyString_AsString(e),(unsigned long)n);
			s[n] = 0;
			}
		Py_DECREF(e);
		}
#endif
	return ucerr;
}

/* hwnd handle to owner window
 * hInst instance handle (we don't use those)
 * options[0]	action only 0 allowed at present
 * options[1]	length of string 0 on input
 * options[2]	length of string 1 on input
 * options[3]	set by this routine to 0
 * options[4]	set by this routine to the length of string s1
 * 				used by this routine for error reporting
 * s0			string 0 (an input)
 * s1			string 1 (we use this for output, but it must have a predeclared size
 * 				in the caller).
 *
 * returns 0 for success non-zero for error(s)
 */
EXPORT(int,UserInstruction,(HWND hWnd, HINSTANCE hInst, double FAR *options, char FAR *s0, char FAR *s1))
{
	rl_embed_rt  rlert = RL_EMBED_INIT;
	rl_embed_rt  *prlert = &rlert;
	PyObject *m;
	char buf[256], *val;
	int	action = (int)options[0],
		ilen = (int)options[1],
		olen = (int)options[2],
		r, n, i;
#if defined(_DEBUG) || defined(_RL_DEBUG)
	FILE*	_dbg = fopen("/tmp/_dbg.txt","wt");
	fprintf(_dbg,"Starting UserInstruction\n");
#endif

	if(pyStart(prlert)){
		write_error("Cannot start up embedded python\n", prlert);
		r = -1;
		}
	else {
		switch(action){
			case 1:
			case 0:
				val = (char*)malloc(ilen+1);
				if(action==1){
					char *p=val, *q=s0, *lim=s0+ilen, *r;
					while(1){
						r = strstr(q,"\r\n");
						if(!r || r>lim){
							r = s0+ilen;
							n = r-q;
							memcpy(p,q,n);
							p += n;
							*p = 0;
							break;
							}
						else {
							n = r-q;
							memcpy(p,q,n);
							p += n;
							q += n+2;
							*p++ = '\n';
							}
						}
					}
				else {
					memcpy(val,s0,ilen);
					val[ilen] = 0;
					}
#if defined(_DEBUG) || defined(_RL_DEBUG)
				fprintf(_dbg,"options=%.2f %.2f %.2f %.2f %.2f\nINPUT='''%s'''\n", options[0],options[1],options[2],options[3],options[4],val);
#endif
				m = _get__main__(val,prlert);
				free(val);
				if(m){
					r = PyRun_SimpleString(_rl_run_string);
#if defined(_DEBUG) || defined(_RL_DEBUG)
					fprintf(_dbg,"PyRun_SimpleString-->%d\n", r);
#endif
					if(r) r = 4;
					VS1("Run completed r=%d\n",r);
					r |= _finish_run(m,prlert);
					Py_DECREF(m);
					}
				break;
			default:
				sprintf(buf,"Illegal value %d for action ie option[0]\n",action);
				write_error(buf,prlert);
				r = -1;
				break;
			}
		}
	options[3] = 0;
#if defined(_DEBUG) || defined(_RL_DEBUG)
	fprintf(_dbg,"rlert.errorString=%p\n", rlert.errorString);
#endif
	if(rlert.errorString){
#if defined(_DEBUG) || defined(_RL_DEBUG)
		fprintf(_dbg,"OUTPUT='''%s'''\n",rlert.errorString);
#endif
		n = min(olen,(int)strlen(rlert.errorString));
		memcpy(s1,rlert.errorString,n);
		if(n<olen) s1[n] = 0;
		free(rlert.errorString);
		}
	else n = 0;

	for(i=n;i<olen;i++) s1[i] = ' ';

	options[4] = n;
	options[0] = r;
	return 1;
}

#if defined(WIN32)
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	if(dwReason==DLL_PROCESS_ATTACH){
		DLL = hInstance;
		VS2("Attach from thread %8.8x DLL=%8.8x\n", GetCurrentThreadId(),DLL);
		}
	else if(dwReason==DLL_PROCESS_DETACH){
		VS("Process Detach\n");
		}
	return TRUE; 
}
#endif
