class RlPres:

    def __init__(self):
        self._objs = {}
        
    def _setObj(self, name, obj):
        self._objs[name] = obj

    def _getObj(self, name):
        return self._objs[name]

    def _delObj(self, name):
        del self._objs[name]
    
    def setPath(self, dir):
        import sys
        sys.path.append(dir)

    def createDrawing(self, drawingName, drawingModule, drawingClass, preview=None):
        exec 'from %s import %s as drawing' % (drawingModule, drawingClass)
        D = drawing()
        if preview is not None: D.__dict__['preview'] = preview
        self._setObj(drawingName, D)
    
    def saveDrawingAsEps(self, drawingName, filename, preview=None):
        import os
        D = self._getObj(drawingName)
        if preview is not None: D.__dict__['preview'] = preview
        D.save(formats=['eps'], outDir=os.path.dirname(filename), fnRoot=os.path.basename(filename))

    def createList(self, name):
        self._setObj(name, [])

    def appendNumberToList(self, name, value):
        self._getObj(name).append(value)

    appendTextToList = appendNumberToList
    
    def appendObjectToList(self, name, objName):
        obj = self._getObj(objName)
        self._getObj(name).append(obj)

    def clearList(self, name):
        del self._getObj(name)[:]
        
    def _setProperty(self, drawingName, propName, value):
        drawing = self._getObj(drawingName)
        exec 'drawing.%s = value' % propName

    setTextProperty = _setProperty
    setNumericProperty = _setProperty

    def setObjectProperty(self, drawingName, propName, objName):
        self._setProperty(drawingName, propName, self._getObj(objName))
        
    def setNoneProperty(self, drawingName, propName):
        self._setProperty(drawingName, propName, None)
    
    def deleteObject(self, name):
        self._delObj(name)
