//code for the DD MM YYYY date
function RL_DATE(pfx,errorMessage,rangeErrorMessage,flags,min,max){
	this.pfx = pfx;
	this.errorMessage = errorMessage;
	this.rangeErrorMessage = rangeErrorMessage;
	this.allowEmpty = flags & 1;
	if(!min) min=100;  // the core JavaScript Date constructor breaks formLevelValidate anyway below this date (100AD)
	this.min = min;
	this.max = max;
	}

RL_DATE.prototype.onload=function(){
	this.form = document.forms[0];
	var D = this.YYYYMMDD().value+'', d='', m='', y='';
	if(D){
		y = D.substring(0,4);
		m = D.substring(4,6);
		d = D.substring(6,8);
		this.YYYYMMDD().value='';
		}
	this.YYYY().value = y;
	this.MM().value = m;
	this.DD().value = d;
	}

RL_DATE.prototype.getObj=function(id){return this.form.elements[this.pfx+id];}
RL_DATE.prototype.DD=function(){return this.getObj('dd');}
RL_DATE.prototype.MM=function(){return this.getObj('mm');}
RL_DATE.prototype.YYYY=function(){return this.getObj('yyyy');}
RL_DATE.prototype.YYYYMMDD=function(){return this.getObj('yyyymmdd');}
RL_DATE.prototype.formatDate=function(d){return d.toDateString();}

RL_DATE.prototype.formLevelValidate=function(){
	var y=this.YYYY().value, m=this.MM().value, d=this.DD().value, v='', dv;
	if(this.allowEmpty && y=='' && m=='' && d=='') v = '';
	else{
		y=parseInt(y,10);
		if(!y || y<0) return 'Invalid year. '+this.errorMessage;
		m=parseInt(m,10);
		if(!m || m<1 || m>12) return 'Invalid month. '+this.errorMessage;

		var dim = new Array(0,31,28,31,30,31,30,31,31,30,31,30,31);
		if( m==2 && (!(y%400) || (!(y%4) && (y%100)))) dim[2] = 29;
		d=parseInt(d,10);
		if(!d || d<1 || d>dim[m]) return 'Invalid day. '+this.errorMessage;
		dv = new Date(y, m-1, d, 0, 0, 0, 0);
		if(dv.valueOf()<this.min.valueOf()) return this.rangeErrorMessage ? this.rangeErrorMessage : ('Date must be on or after '+this.formatDate(this.min));
		if(dv.valueOf()>this.max.valueOf()) return this.rangeErrorMessage ? this.rangeErrorMessage : ('Date must be on or before '+this.formatDate(this.max));
		dd = this.DD().value = rl_zeroPadInt(d,2);
		mm = this.MM().value = rl_zeroPadInt(m,2);
		// need to use getFullYear because Date constructor assumes eg. 1978 for year 78
		yyyy = this.YYYY().value = rl_zeroPadInt(dv.getFullYear(),4);
		v = yyyy+mm+dd;
		}
	this.YYYYMMDD().value = v;
	return '';
	}
