function _rl_hideTr(tr,hide){
	tr.style.display = hide ? 'none' : ''; 
	_rl_hideElement(tr,hide);
	}
function _rl_isControl(el){return el.tagName == 'INPUT' || el.tagName == 'SELECT';}
function _rl_hideElement(el,hide){
	el.style.display = hide ? 'none' : ''; 
	if (_rl_isControl(el) &&
			!(/:eb$/.exec(el.getAttribute('name')))){ //don't disable QChoice 'other' textbox
		el.disabled = hide;
		return
		}
	var node = el.firstChild;
	while (node){
		if (node.nodeType == 1) _rl_hideElement(node,hide);
		node = node.nextSibling;
		}
	}
function _rl_isSubsectionStartTr(el){
	if (el.tagName == 'TR' && el.id.substr(0,5) == 'start')
		return el.id.substr(5);
	else
		return false;
}
function _rl_sectionStartTr(name){
	r = getElementWithId('start'+name);
	return r;
	}
function _rl_hideSection(name,hide){
	// hide: boolean, or -1 for don't change hidden state
	var node, endTr;
	node = _rl_sectionStartTr(name).nextSibling;
	endTr = getElementWithId('end'+name);
	while (node!=endTr){
		if (node.nodeType == 1){
			if (!hide && (name = _rl_isSubsectionStartTr(node))){
				node = _rl_hideSection(name,-1);  // skip subsection
				}
			else if (hide != -1){
				_rl_hideTr(node,hide);
				}
			}
		node = node.nextSibling;
		}
	return node;
	}
function _rl_scheduleHide(name,hide){
	setClassAttr(_rl_sectionStartTr(name),(hide ? 'rlDivHidden' : ''));
	}
function rl_updateHideableSection(name){
	var hide = (_rl_sectionStartTr(name).getAttribute('class') == 'rlDivHidden');
	_rl_hideSection(name,hide);
	}
function rl_hideSection(name,hide){
	_rl_scheduleHide(name,hide);
	rl_updateHideableSection(name);
	}

function rl_optVal(name){
	var sel = document.getElementsByName(name)[0];
	var opt = sel.options[sel.selectedIndex];
	if (!opt) return null;
	return opt.value;
	}
function rl_checkRegex(fieldName, msg, regex){
	var eb = document.forms[0].elements[fieldName];
	if (eb.disabled) return '';
	if(regex){
		return (regex.exec(eb.value)==null)?msg:'';
		}
	else{ //required
		return (/^\s*$/.exec(eb.value)!=null)?msg:'';
		}
	}

function rl_zeroPadInt(n,nrDigits) {
	var r=''+n, nrPadDigits = (nrDigits - (''+n).length);
	nrPadDigits = nrPadDigits>0 ? nrPadDigits: 0;
	for(var ii=0;ii<nrPadDigits;ii+=1) r='0'+r;
	return r;
}
function rl_qbase_intDiv(dd,dv){return Math.floor((dd/dv)-((dd%dv)/dv))};
function rl_qbase_dpFormat(f,n,trim,addCommas,curSymbol){
	var dp=Math.pow(10,n), s, neg;
	neg = (f!=(f=Math.abs(f)));
	if(f<1e-8) return '0';
	s = ''+Math.floor(f*dp);
	dp = s.slice(-n);
	s = s.slice(0,s.length-n);
	if(trim) dp = dp.replace(/0+$/,'');
	if(addCommas){
		var ii = 0;
		var nrCommas = rl_qbase_intDiv(s.length-1,3);
		while(ii < nrCommas) {
			s = s.substring(0,s.length-(4*ii+3))+','+s.substring(s.length-(4*ii+3));
			ii++;
		   }
		}
	return (neg?'-':'')+(curSymbol?curSymbol:'')+s+(dp?('.'+dp):'');
	}
function RL_FLOAT(id,min,max,label,required){
	this._init(id,min,max,label,required);
	}
RL_FLOAT.prototype._init=function(id,min,max,label,required){
	this.id = id;
	this.min = min;
	this.max = max;
	this.label = label;
	this.required = required;
	}
RL_FLOAT.prototype.parse=function(val){return parseFloat(val);}
RL_FLOAT.prototype.changed=function(){
	var ctl = this.control();
	var val = this.parse(ctl.value);
	if(isNaN(val)){
		ctl.value = "0";
		}
	else{
		ctl.value = (Math.round(val*100)/100.0).toString();
		}
	}
RL_FLOAT.prototype.getForm=function(){
	return document.forms[0];
	}
RL_FLOAT.prototype.control=function(){
	return this.getForm().elements[this.id];
	}
RL_FLOAT.prototype.formatMoney=function(val){
	return rl_qbase_dpFormat(val,2,1,1,'\xa3');
}
RL_FLOAT.prototype.validate=function(){
	var val = this.control().value;
	if(val==""){
		if(this.required) return 'Please supply a value for '+this.label;
		}
	else{
		val = this.parse(val);
		if(isNaN(val)) return 'Please supply a valid value for '+this.label;
		if(this.min!=null && val<this.min) return this.label+' must be greater than or equal to '+this.formatMoney(this.min);
		if(this.max!=null && val>this.max) return this.label+' must be less than or equal to '+this.formatMoney(this.max);
		}
	return '';
	}
RL_FLOAT.prototype.value=function(numeric){
	var val = this.control().value;
	if(numeric) val = parseFloat(val);
	return val;
	}
function RL_INT(id,min,max,label,required){
	this._init(id,min,max,label,required);
	}
RL_INT.prototype = new RL_FLOAT(null,null,null,null);
RL_INT.prototype.parse=function(val){return parseInt(val);}

RL_OTHERDD_SAVEDBG={};
function RL_OTHERDD_ONCHANGE(dd){
	var eb=dd.form.elements[dd.name.replace(/:dd$/,'')+':eb'],x=dd.options.selectedIndex;
	x=x>=0&&x<dd.options.length?dd.options[x].value:'';
	eb.disabled = x!='*other*';
	if(eb.disabled){
		eb.value = '';
		if(RL_OTHERDD_SAVEDBG[dd.name]==null)
			RL_OTHERDD_SAVEDBG[dd.name] = eb.currentStyle ? eb.currentStyle.background : window.getComputedStyle(eb,null).background;
		eb.style.background = 'lightgrey';
		}
	else {
		if(RL_OTHERDD_SAVEDBG[dd.name]){
			alert(''+RL_OTHERDD_SAVEDBG[dd.name]);
			eb.style.background = RL_OTHERDD_SAVEDBG[dd.name];
			}
		else{
			eb.style.background = "white";
			}
		}
	}
function RL_OTHERDD_ONLOAD(name){
	var e=document.forms[0].elements;
	RL_OTHERDD_ONCHANGE(e[name+':dd']);
	e[name].value = '';
	}
function RL_OTHERDD_ONSUBMIT(name,required_msg){
	var e=document.forms[0].elements, eb=e[name+':eb'], x, dd=e[name+':dd'];
	if(dd.disabled) return '';
	if(eb.disabled){
		x=dd.options.selectedIndex;
		x = x>=0&&x<dd.length ? dd.options[x].value : '';
		}
	else x = eb.value;
	if(required_msg && !x) return required_msg;
	e[name].value = x;
	return '';
	}
function RL_single_choice_Required(name,msg){
	dd = document.forms[0].elements[name];
	if(dd.disabled) return ''
	return dd.selectedIndex>=0?'':msg
	}
function RL_multi_choice_Required(name,msg){
	var i,e=document.forms[0].elements,allDisabled=1;
	for(i=0;i<e.length;i++){
		if(e[i].name==name && e[i].checked) return "";
		if(!e[i].disabled) allDisabled=0
		}
	if(allDisabled) return '';
	return msg;
	}
