#stub - to be completed.
import os, time
from types import ListType, StringType, TupleType

import pyRXP
from rlextra.radxml import xmlutils
import rlextra.forms
from rlextra.forms.qbase import QBase, QAddStartDiv, QAddEndDiv
from rlextra.forms.qwidget import DynamicQWidget

def findDtdDir():
    return os.path.dirname(rlextra.forms.__file__)

def parseQdfFile(filename, questionnaire,
                 dtdDir=None,prefix='', overrideName=None, eoCB=None, ):
    "Returns a QBase class from a file"
    from reportlab.lib.utils import open_and_read
    xmlText = open_and_read(filename, 't')
    return parseQdfText(xmlText,questionnaire,dtdDir,prefix,overrideName,eoCB=eoCB)


def parseQdfText(text, questionnaire,
                 dtdDir=None,prefix='', overrideName=None, eoCB=None):
    "Returns a QBase class from text xml input"
    import md5
    digest = md5.md5(text).hexdigest()
    parse = pyRXP.Parser(eoCB=eoCB).parse
    if not eoCB and (dtdDir or dtdDir is None):
        cwd = os.getcwd()
        try:
            if not dtdDir: dtdDir=findDtdDir()
            os.chdir(dtdDir)
            tree = parse(text)
        finally:
            os.chdir(cwd)
    else:
        tree = parse(text)
    xmlutils.stripWhitespace(tree)
    return digest, makeObjects(tree, questionnaire, prefix=prefix, overrideName=overrideName)

def addChild(object, child):
    # XXX yuck
    # XXX yuck #2: Questionnaire.__init__ has to munge parent links of its immediate children
    if hasattr(object, 'addChild'):
        child._parent = object
        object.addChild(child)
    else:
        child._parent = object
        try:
            object.children.append(child)
        except AttributeError:
            object.children = [child]

def makeObjects(tagTree, questionnaire, defaultClass=QBase, prefix='',overrideName=None,parent=None):
    """Generic routine for mapping XML onto a tree of objects.

    For each tag it tries to find a corresponding class, and
    instantiates one.  If it cannot do so, it uses the default
    class passed in using the None dictionary key in the class map."""
    #started = time.clock()
    (tagName, attrs, children, stuff) = tagTree
    nameAttr = attrs.get('name')
    classAttr = attrs.get('class')
    object = questionnaire.createQbase(prefix, tagName, classAttr, nameAttr, defaultClass)
    if attrs is not None:
        for (key, value) in attrs.items():
            setattr(object, key, value)
    if questionnaire.httpDir is not None:
        object.httpDir = questionnaire.httpDir
    if overrideName:
        object.name = overrideName

    if tagName != 'addDiv':
        parentOfChildren = object
    else:
        parentOfChildren = parent

    if children not in (None, []):
        #what to do with them?
        prefixOfChildren = parentOfChildren.dottedName()
        if tagName == 'addDiv':
            addChild(parentOfChildren, object)
        for child in children:
            if type(child) in (ListType, TupleType):
                ch = makeObjects(child, questionnaire, defaultClass=defaultClass, prefix=prefixOfChildren, parent=parentOfChildren)
            else: #string
                ch = child
            if not isinstance(ch, QAddStartDiv):
                addChild(parentOfChildren, ch)
        if tagName == 'addDiv':
            end = questionnaire.createQbase(prefix, None, None, object.name, QAddEndDiv)
            end.name = object.name
            addChild(parentOfChildren, end)

    if hasattr(object, 'postInit'):
        object.postInit()
    if hasattr(object, 'default') and hasattr(object, 'setTextValue'):
        object.setTextValue(object.default)
    #finished = time.clock()
    #print 'constructed <%s> and contents in %0.4f seconds' % (tagName, finished-started)
    return object

def test():
    import time
    started = time.clock()
    q = parseQdfFile('test\\example2_fund.qdf')
    finished = time.clock()
    print 'parsed in %0.4f seconds' % (finished-started)
    return q

if __name__=='__main__':
    test()
