#   Code to produce code for Fidelity date widget
#
from rlextra.forms.qwidget import QWidget

class Sortcode_Widget(QWidget):
    def __init__(self,**kw):
        QWidget.__init__(self,
                _kw=kw,
                name='sortcode',
                editable=1,
                allowEmpty=1,
                label="sortcode",
                errorMessage="Please enter a valid sort code",
                shortHelp="Enter sort code as 00-00-00",
                longHelp="",
                httpDir = '/res',
                jsFileName = 'sortcode_base',
                SC1='',
                SC2='',
                SC3='',
                SORTCODE='',
                )

    def postInit(self):
        QWidget.postInit(self)
        #integer attribs
        for n in ('allowEmpty',):
            setattr(self,n,int(getattr(self,n)))
        self._get_pfxname()
        self.form = 'document.forms[0]' # this is what we assume
        self.widname = self.name.replace('.','_')+'_DW'

        self.setChildDict(('SC1','SC2','SC3','SORTCODE'))
        opts = 0
        for n,d in (('allowEmpty',1),):
            opts |= getattr(self,n,0) and d or 0
        self._flags = opts

    def getDText(self):
        dText=[]
        def d(txt,a=dText.append,fmt=self._fmt):
            a(fmt(txt))
        self._v_SC1 = self.childDict['SC1']
        self._v_SC2 = self.childDict['SC2']
        self._v_SC3 = self.childDict['SC3']
        self._v_SORTCODE = self.childDict['SORTCODE']
        d('<tr><td>%(label)s<input type="hidden" name="%(_pfxname)sSORTCODE" value="%(_v_SORTCODE)s"></td>')
        if self.editable:
            d('<td nowrap><input type="text" size="2" maxlength="2" name="%(_pfxname)sSC1">')
            d('&nbsp;-&nbsp;<input type="text" size="2" maxlength="2" name="%(_pfxname)sSC2">')
            d('&nbsp;-&nbsp;<input type="text" size="2" maxlength="2" name="%(_pfxname)sSC3"></td>')
            d('<td align="right">%s</td></tr>' % self._getDotHelp())
            #d('<td><b><p tooltip="%(longHelp)s" ttclass="tooltip">Help</p></b></td></tr>')
        else:
            d('<td nowrap>%(_v_SC1)s/%(_v_SC2)s/%(_v_SC3)s')
            d('<input type="hidden" name="%(_pfxname)sSC1">')
            d('<input type="hidden" name="%(_pfxname)sSC2">')
            d('<input type="hidden" name="%(_pfxname)sSC3"></td>')
        self.dText = '\n'.join(dText)
        return self.dText

    def getIText(self):
        if not self.editable:
            self.iText = ''
        else:
            self.iText = self._fmt('var %(widname)s = new RL_SORTCODE("%(_pfxname)s","%(errorMessage)s",%(_flags)d);')
        return self.iText

    def getLText(self):
        if not self.editable:
            self.lText = ''
        else:
            self.lText = self._fmt('%(widname)s.onload();\n')
        return self.lText

    def getVText(self):
        if not self.editable:
            self.vText = ''
        else:
            self.vText = self._fmt('%(widname)s.formLevelValidate()')
        return self.vText

if __name__=='__main__': #noruntests
    from rlextra.utils.buildutils import getFlag
    def boolFlag(name,d=0,has=1):
        return (getFlag((has and '--has' or '')+name,0,d) and not getFlag('--no'+name)) and 1 or 0

    if getFlag('--saveAFiles'):
        Sortcode_Widget().saveAFile()
    else:
        Sortcode_Widget(
            httpDir = getFlag('--httpDir',1,'/wefbranding'),
            ).buildTestHTML(getFlag('--fn',1,'test_fs.html'))
